#!/usr/bin/env python

import cgitb; 
import cgi
import urllib
import xml.dom.minidom
import re

	
gInsertTagGood =  "<br/><span style='background-color: green; color: white; padding-bottom:1px;'>&nbsp;Rated <b>good</b>&nbsp;</span><br/>"
gInsertTagBad =  "<br/><span style='background-color: orange; color: white; padding-bottom:1px;'>&nbsp;Rated <b>bad</b>&nbsp;</span><br/>"
gInsertTagDangerous =  "<br/><span style='background-color: red; color: white; padding-bottom:1px;'>&nbsp;Rated <b>DANGEROUS</b>&nbsp;</span><br/>"

# read parameters
form = cgi.FieldStorage()
if form.has_key("q"):
	q = form["q"].value
	isLocal = 0;
	
else:
	q = "xul" # TODO
	isLocal = 1;
	
if not isLocal:
	cgitb.enable()

# function to generalize a url to it's domain.  (http://www.google.com  -> google.com)
# isFilepathOkay decides if a result should be returned even if there is filepath info, eg. http://www.google.com/somepage.html 
def generalizeUri(uri,isFilepathOkay=1):
	r = re.compile("^https?.//[^/]*?([^/.]+?\.[^/.]+?)/(.*)$",re.M)
	fr = r.search("\n"+uri);
	if ((fr) and (isFilepathOkay or (fr.group(2)==""))):
		return fr.group(1)
	else:
		return ""
		
def doSearch(query):
	searchUrl = 'http://search.yahoo.com/search?p='+query+'&sm=Yahoo%21+Search&fr=FP-tab-web-t&toggle=1'
	pageFileObject = urllib.urlopen(searchUrl)
	searchResultsHtml =  pageFileObject.read()
	return searchResultsHtml

def parseSearch(pageHtml):
	#p = re.compile('<li><div><a class=yschttl ? href="http://rds\.yahoo\.com.+?\*-([^"]+)">.*?More from this site</a>',re.DOTALL) # .More from this site</a>
	p = re.compile('<li><div><a class=yschttl (?:id="([^"]*?)")? href="http://rds\.yahoo\.com.+?\*-([^"]+)">.*?More from this site</a>',re.DOTALL) # .More from this site</a>
	
	iterator = p.finditer(pageHtml)
	serachResultsList = []
	end = 0
	for match in iterator:
		if end == 0:
			start = match.start()
		end = match.end()
		if match.group(1):
			url = match.group(1)
		else:
			url = match.group(2)
		url = urllib.unquote(url)
		serachResultsList.append([url,match.group(0)])
	return [start,end,serachResultsList]

def loadTrustBase(path):
	trustBaseDb = {}
	test_xml = xml.dom.minidom.parse(path)
	for i in test_xml.getElementsByTagName("uri"):
		uri = i.firstChild.data
		t = i.parentNode.getElementsByTagName("trust")
		if t:
			# add uri to our dictionary
			trustBaseDb[uri] = t[0].getAttribute("degree");
			
			# add another entry for just the domain, (but only if there's no specific page mentioned)
			g = generalizeUri(uri,0)
			if g:
				trustBaseDb[g] = t[0].getAttribute("degree")
			
			#r = re.compile("^https?.//[^/]*?([^/.]+?\.[^/.]+?)/(.*)$",re.M)
			#fr = r.search("\n"+uri);
			#if ((fr) and (fr.group(2)=="")):
			#	# there is no filepath
			#	# add pure domain to our dictionary
			#	trustBaseDb[fr.group(1)] = t[0].getAttribute("degree")
			
		#print i.firstChild.data
	return trustBaseDb

def lookupUri(uri):
	if gTrustBaseDb.has_key(uri):
		return int(gTrustBaseDb[uri])
	else:
		g = generalizeUri(uri)
		if gTrustBaseDb.has_key(g):
			return int(gTrustBaseDb[g])
		else:
			return
			

def go(query):
	searchResultsHtml = doSearch(query)
	[start,end,results] =  parseSearch(searchResultsHtml)

	print 'Content-type: text/html\n'

	if not isLocal:
		# beginning
		print searchResultsHtml[:start]

		# middle
		for [Url,DesHtml] in results:
			degree = lookupUri(Url)
			if degree:
				if (degree>0):
					DesHtml = DesHtml+gInsertTagGood
				elif (degree<-25):
					DesHtml = DesHtml+gInsertTagDangerous 
				elif (degree<0):
					DesHtml = DesHtml+gInsertTagBad
			print DesHtml

	if isLocal:
		# debug
		for [Url,DesHtml] in results:
			print Url
			print lookupUri(Url)
			print "<br/>"	
		print "<code>" + repr(gTrustBaseDb) + "</code>"

	if not isLocal:		
		# end
		print searchResultsHtml[end:]

# main
gTrustBaseDb = loadTrustBase("stan_base.xml")
go(q)




