/*
Copyright 2005 Stanley James
*/

BEGIN; 

-- Set hops to default high number
UPDATE tblInformerProfiles
SET hops = 999
;

DELETE FROM tblChain;

INSERT INTO tblChain (hops,i1)
SELECT 
	1, R1.link
FROM
	tblReports R1
WHERE
	R1.isInformerStatement = 1
	AND R1.informer = 'http://www.trustbase.org/users/stan.xml'
	-- no loops
	AND R1.link <> 'http://www.trustbase.org/users/stan.xml' -- user isn't reporting on himself
;

INSERT INTO tblChain (hops,i1,i2)
SELECT DISTINCT
	2, R1.link, C.i1
FROM
	tblReports R1, tblChain C
WHERE
	R1.isInformerStatement = 1
  AND C.i1 = R1.informer
  AND C.hops = 1
  -- no loops
  AND R1.link <> 'http://www.trustbase.org/users/stan.xml'
  AND R1.link <> C.i1
  AND R1.link NOT IN 
  (
  	SELECT i1
  	FROM tblChain
  )
;

INSERT INTO tblChain (hops,i1,i2, i3)
SELECT DISTINCT
	3, R1.link, C.i1, C.i2
FROM
	tblReports R1, tblChain C
WHERE
	R1.isInformerStatement = 1
  AND C.i1 = R1.informer
  AND C.hops = 2  
  -- no loops
  AND R1.link <> 'http://www.trustbase.org/users/stan.xml'
  AND R1.link <> C.i1
  AND R1.link <> C.i2
  AND R1.link NOT IN 
  (
  	SELECT i1
  	FROM tblChain
  )
  
;

INSERT INTO tblChain (hops,i1,i2, i3, i4)
SELECT DISTINCT
	4, R1.link, C.i1, C.i2, C.i3
FROM
	tblReports R1, tblChain C
WHERE
	R1.isInformerStatement = 1
  AND C.i1 = R1.informer
  AND C.hops = 3  
  -- no loops
  AND R1.link <> 'http://www.trustbase.org/users/stan.xml'
  AND R1.link <> C.i1
  AND R1.link <> C.i2
  AND R1.link <> C.i3
  AND R1.link NOT IN 
  (
  	SELECT i1
  	FROM tblChain
  )
  
;

INSERT INTO tblChain 
	(hops, i1, i2, i3, i4, i5)
SELECT DISTINCT
	5, R1.link, C.i1, C.i2, C.i3, C.i4
FROM
	tblReports R1, tblChain C
WHERE
	R1.isInformerStatement = 1
  AND C.i1 = R1.informer
  AND C.hops = 4  
  -- no loops
  AND R1.link <> 'http://www.trustbase.org/users/stan.xml'
  AND R1.link <> C.i1
  AND R1.link <> C.i2
  AND R1.link <> C.i3
  AND R1.link <> C.i4
  AND R1.link NOT IN 
  (
  	SELECT i1
  	FROM tblChain
  )
  
;

UPDATE tblInformerProfiles
SET hops = (
	SELECT MIN(hops) FROM tblChain WHERE i1 = uri
)
;

-- TODO: delete entrys with hops more than min found?


COMMIT;