from xml.dom.minidom import getDOMImplementation
import re, urllib
import apsw
from Ft.Lib import Uri
from Ft.Xml import InputSource
from Ft.Xml.Xslt.Processor import Processor
from xml.dom.minidom import parseString
import sys

import dateFormat, datetime
global gSuzanneDateFormat
gSuzanneDateFormat = "Y-m-dTH:i:sZ"

global false, true
true = 1
false = 0

def getStatement(params, cursor, serverVars, data):
	print "___MDDB:get statement begin"
	showSQL = false
	
	# setup our XML (it will later be transformed into RSS)
	impl = getDOMImplementation()
	newdoc = impl.createDocument(None, "results", None)
	results_element = newdoc.documentElement		
			 	 	
	SQL = """
		SELECT
			uri, name, link, description, image, pubKey, maxPing, tags
		FROM
			tblInformerProfiles
		WHERE
			uri = '%s'
	""" % (serverVars["userURI"])
	try:	
		for (uri, name, link, description, image, pubKey, maxPing, tags) in cursor.execute(SQL):	
			print name
			informer_element = newdoc.createElement("informer")
			results_element.appendChild( informer_element )

			urelement = newdoc.createElement("uri")
			urelement.appendChild( newdoc.createTextNode(uri) )
			informer_element.appendChild( urelement )
			name_element = newdoc.createElement("name")
			name_element.appendChild( newdoc.createTextNode(name) )
			informer_element.appendChild( name_element )
			link_element = newdoc.createElement("link")
			link_element.appendChild( newdoc.createTextNode(link) )
			informer_element.appendChild( link_element )
			description_element = newdoc.createElement("description")
			description_element.appendChild( newdoc.createTextNode(description) )
			informer_element.appendChild( description_element )
			image_element = newdoc.createElement("image")
			image_element.appendChild( newdoc.createTextNode(image) )
			informer_element.appendChild( image_element )
			pubKey_element = newdoc.createElement("pubKey")
			pubKey_element.appendChild( newdoc.createTextNode(str(pubKey)) )
			informer_element.appendChild( pubKey_element )
			maxPing_element = newdoc.createElement("maxPing")
			maxPing_element.appendChild( newdoc.createTextNode(str(maxPing)) )
			informer_element.appendChild( maxPing_element )
			#hops_element = newdoc.createElement("hops")
			#hops_element.appendChild( newdoc.createTextNode(hops) )
			#informer_element.appendChild( hops_element )
			
	except apsw.MisuseError: #TODO: WTF is this "non-error"?
		pass	

	SQL = """
		SELECT
			link, scope, title, isInformerStatement, quality, date, description, tags
		FROM
			tblReports
		WHERE
			informer = '%s'
		;
	""" % (serverVars["userURI"])
	try:	
		for (link, scope, title, isInformerStatement, quality, date, description, tags) in cursor.execute(SQL):
			print link

			# python is dumb
			if (not (link)):
				link = ""
			if (not (scope)):
				scope = ""
			if (not (title)):
				title = ""
			if (not (isInformerStatement)):
				isInformerStatement = ""
			if (not (quality)):
				quality = ""
			if (not (date)):
				date = ""
			if (not (description)):
				description = ""
			if (not (tags)):
				tags = ""
			
			report_element = newdoc.createElement("report")
			results_element.appendChild( report_element )
							
			link_element = newdoc.createElement("link")
			link_element.appendChild( newdoc.createTextNode(link) )
			report_element.appendChild( link_element )
			scope_element = newdoc.createElement("scope")
			scope_element.appendChild( newdoc.createTextNode(scope) )
			report_element.appendChild( scope_element )
			title_element = newdoc.createElement("title")
			title_element.appendChild( newdoc.createTextNode(title) )
			report_element.appendChild( title_element )
			isInformerStatement_element = newdoc.createElement("isInformerStatement")
			isInformerStatement_element.appendChild( newdoc.createTextNode(isInformerStatement) )
			report_element.appendChild( isInformerStatement_element )
			quality_element = newdoc.createElement("quality")
			quality_element.appendChild( newdoc.createTextNode(quality) )
			report_element.appendChild( quality_element )
			date_element = newdoc.createElement("date")
			date_element.appendChild( newdoc.createTextNode(date) )
			report_element.appendChild( date_element )
			description_element = newdoc.createElement("description")
			description_element.appendChild( newdoc.createTextNode(description) )
			report_element.appendChild( description_element )
			tags_element = newdoc.createElement("tags")
			tags_element.appendChild( newdoc.createTextNode(tags) )
			report_element.appendChild( tags_element )
			
	except apsw.MisuseError: #TODO: WTF is this "non-error"?
		pass	
	
	print "___MDDB:Finished getStatement"
	print
	
	d = datetime.datetime.now()
	df = dateFormat.DateFormat(d)
	nowString = df.format(gSuzanneDateFormat)	
	
	SQL = """
		REPLACE INTO 
			tblSystemVars
		VALUES
			('uploadDate','%s')
	""" % (nowString)
	try:	
		cursor.execute(SQL)
	except apsw.MisuseError: #TODO: WTF is this "non-error"?
		pass	

	
	# TODO: this is dumb...why are there so many damned XML formats? 
	documentInputSource = InputSource.DefaultFactory.fromString(newdoc.toxml("utf-8"), serverVars["userURI"])	
	stylesheet = InputSource.DefaultFactory.fromUri( Uri.OsPathToUri(serverVars["base_path"]+"xsl/raw_2_rss.xsl") )
	
	processor = Processor()
	processor.appendStylesheet(stylesheet)
	RSS = processor.run(documentInputSource)
		
	print "type(RSS)",type(RSS)
	
	return RSS