from xml.dom.minidom import getDOMImplementation
import re, urllib
import apsw

import mddb_URIstripper

global false, true
true = 1
false = 0


def lookupURI(params, cursor, serverVars):
	URIs = []
	exact = false
	includeProfile = false # include user profile in results
	statementsWhere = "" # only return results that are reports on informer statements
	includeTags = false # include tags in results
	onlyFirst = false # only give the first (top) result (ie most trusted) for each URI # TODO: OPTIMIZE: this is needed for the deep commenting feature...no need to get all that info which isn't used
	showSQL = false
	for (param,value) in params:
		if (param=="URIs"):
			URIs=re.split(',',value)
		#elif (param=="exact"):
		#	exact=value
		#elif (param=="includeProfile"):
		#	includeProfile=value
		elif (param=="onlyStatements"):
			if (value=="1"):
				statementsWhere="AND R.isInformerStatement = 1"
		#elif (param=="includeTags"):
		#	includeTags=value
		#elif (param=="onlyFirst"):
		#	onlyFirst=value
		elif (param=="SQL"):
			showSQL = true
		
	# setup our XML output
	impl = getDOMImplementation()
	newdoc = impl.createDocument(None, "results", None)
	results_element = newdoc.documentElement		
	
	for URI in URIs:
		# defend against SQL injection
		if (URI.find(";")!=-1):
			continue;
	
		reports_element = newdoc.createElement("reports")
		reports_element.setAttribute("uri",URI)
		results_element.appendChild(reports_element)
		
		# Decompose URI
		decomp = mddb_URIstripper.decomposeURI(URI)
		URI_text_list = "'*"+decomp["subdomain"]+"."+decomp["baseAuthority"]+"*',"+\
		                "'*"+decomp["baseAuthority"]+"*'"		                
		#print "___MDDB: processing uri":URI
		SQL = """
			SELECT 
				I.uri,
				I.name,
				I.link,
				I.description,
				I.image,
				I.hops,
				R.scope,
				R.link,
				R.title,
				R.isInformerStatement = '1' AS isInformerStatement2,
				R.quality,
				R.date,
				R.description,
				R.tags
			FROM
				tblReports R,
				tblInformerProfiles I
			WHERE
				(R.scope in (%s) OR R.link='%s')
				AND	R.informer = I.uri
				%s
			ORDER BY
				isInformerStatement2 DESC,
				R.scope,
				I.hops, 
				R.date
			"""  % ( URI_text_list, URI, statementsWhere )
		#print SQL
		count = 0
		for (uri, \
			name, \
			i_link, \
			i_description, \
			image, \
			hops, \
			scope, \
			link, \
			title, \
			isInformerStatement, \
			quality, \
			date, \
			description, \
			tags) \
		in cursor.execute(SQL):
			count += 1

			# this is dumb. I wish I had javascript here.							
			uri=("", uri)[bool(uri)]
			name=("", name)[bool(name)]
			link=("", link)[bool(link)]
			description=("", description)[bool(description)]
			image=("", image)[bool(image)]
			hops=(repr(hops))
			scope=("", scope)[bool(scope)]
			link=("", link)[bool(link)]
			title=("", title)[bool(title)]
			isInformerStatement=("0", "1")[bool(isInformerStatement)]
			quality=("", quality)[bool(quality)]
			date=("", date)[bool(date)]
			description=("", description)[bool(description)]
			tags=("", tags)[bool(tags)]

			print "type(description)",type(description)
			print "type(tags)",type(tags)
			
			# enforce rules
			if isInformerStatement=="1":
				scope=""
			if link==scope:
				scope=""
			# discard chrome URI's
			if (link[:6]=="chrome"):
				print "___MDDB: skipping chrome link URI"
				continue
				
			report_element = newdoc.createElement("report")
			reports_element.appendChild( report_element )
								
			scope_element = newdoc.createElement("scope")
			scope_element.appendChild( newdoc.createTextNode(scope) )
			report_element.appendChild( scope_element )
			link_element = newdoc.createElement("link")
			link_element.appendChild( newdoc.createTextNode(link) )
			report_element.appendChild( link_element )
			isInformerStatement_element = newdoc.createElement("isInformerStatement")
			isInformerStatement_element.appendChild( newdoc.createTextNode(isInformerStatement) )
			report_element.appendChild( isInformerStatement_element )
			quality_element = newdoc.createElement("quality")
			quality_element.appendChild( newdoc.createTextNode(quality) )
			report_element.appendChild( quality_element )
			date_element = newdoc.createElement("date")
			date_element.appendChild( newdoc.createTextNode(date) )
			report_element.appendChild( date_element )
			description_element = newdoc.createElement("description")
			description_element.appendChild( newdoc.createTextNode(description) )
			report_element.appendChild( description_element )
			tags_element = newdoc.createElement("tags")
			tags_element.appendChild( newdoc.createTextNode(tags) )
			report_element.appendChild( tags_element )
			
			title_element = newdoc.createElement("title")
			title_element.appendChild( newdoc.createTextNode(title) )
			report_element.appendChild( title_element )

			informer_element = newdoc.createElement("informer")
			report_element.appendChild( informer_element )

			uri_element = newdoc.createElement("uri")
			uri_element.appendChild( newdoc.createTextNode(uri) )
			informer_element.appendChild( uri_element )
			name_element = newdoc.createElement("name")
			name_element.appendChild( newdoc.createTextNode(name) )
			informer_element.appendChild( name_element )
			i_link_element = newdoc.createElement("link")
			i_link_element.appendChild( newdoc.createTextNode(i_link) )
			informer_element.appendChild( i_link_element )
			i_description_element = newdoc.createElement("description")
			i_description_element.appendChild( newdoc.createTextNode(i_description) )
			informer_element.appendChild( i_description_element )
			image_element = newdoc.createElement("image")
			image_element.appendChild( newdoc.createTextNode(image) )
			informer_element.appendChild( image_element )
			hops_element = newdoc.createElement("hops")
			hops_element.appendChild( newdoc.createTextNode(hops) )
			informer_element.appendChild( hops_element )

				
	
#		print SQL
		
#		if showSQL:
#			out = out + "<DEBUG_sql>"+SQL+"</DEBUG_sql>"
#		out = out + "</reports>"				
	
	#print newdoc.toxml().encode('latin-1')	
	return newdoc.toxml()	