from xml.dom.minidom import getDOMImplementation
import re, urllib
import apsw

import mddb_URIstripper

global false, true
true = 1
false = 0

def nextSyncInformer(params, cursor, serverVars):
	maxHops = 3   # maximum hops away for any informer uri found
	maxDate = "9999-99-99" # maximum vist date for a uri (anything newer has been too recently visited.)
	forceURI = ""
	for (param,value) in params:
		if (param=="maxHops"):
			maxHops=int(value)
		if (param=="maxDate"):
			maxDate=value
			
	# setup our XML output
	impl = getDOMImplementation()
	newdoc = impl.createDocument(None, "results", None)
	results_element = newdoc.documentElement		
	
	# just in case it's still there (it shouldn't be...), drop our temp table.
	try:
		cursor.execute("DROP TABLE tmpBadURIs;")
	except:
		pass

	# first see if we need to upload our own statement
	
	SQL = """
		SELECT varValue
		FROM tblSystemVars
		WHERE varName = 'uploadDate' AND varValue<'%s'
		;
	""" % (maxDate)
	uploadDate = 0
	try:
		for x in cursor.execute(SQL):
			uploadDate = x[0]
	except apsw.MisuseError: #TODO: WTF is this "non-error"?
		pass	
		
	if uploadDate != 0:
	
		print "Time for user upload"
		print uploadDate
		
#		uri_element = newdoc.createElement("informerURI")
#		uri_element.appendChild( newdoc.createTextNode(serverVars["userURI"]) )
#		results_element.appendChild( uri_element )
#
#		visitDate_element = newdoc.createElement("visitDate")
#		visitDate_element.appendChild( newdoc.createTextNode(uploadDate) )
#		results_element.appendChild( visitDate_element )
#
#		modifiedDate_element = newdoc.createElement("modifiedDate")
#		modifiedDate_element.appendChild( newdoc.createTextNode("") )
#		results_element.appendChild( modifiedDate_element )
		
		userSQL = """
			UNION
			SELECT '%s', 0, '%s', ''
		""" % (serverVars["userURI"] , uploadDate)
	else:
		userSQL = ""
		

	#	/* get next informer to be updated
	#	 *
	#	 * First priority are newly added informers that have never had their statement downloaded.
	#	 *   Among these, priority is given to those that are closest (hops) to the user.
	#	 * Second priority are informers that we've already visited (or attempted to) before.
	#	 *   Among these, priority is given to those that we visited the longest ago.
	#	 */

	SQL = """

		CREATE TEMP TABLE tmpBadURIs 
		(
			uri TEXT PRIMARY KEY -- uri of informer statement
		)
		;

		INSERT INTO 
			tmpBadURIs
		SELECT 
			P1.uri
		FROM 
			tblInformerProfiles P1, tblInformerProfiles P2, tblReports R
		WHERE 
			R.link = P1.uri
			AND R.informer = P2.uri
			AND R.quality < 0
			AND P2.hops < P1.hops			
		;

		SELECT
			R.link, P.hops, '' AS visitDate, '' AS modifiedDate
		FROM 
			tblReports R, tblInformerProfiles P
		WHERE
			R.isInformerStatement = '1'
			AND P.uri = R.informer
			AND P.hops < %s
			AND R.link NOT IN
			(
				SELECT informer
				FROM tblInformerDownload
			)
			AND R.link NOT IN
			(
				SELECT uri FROM tmpBadURIs
			)

		UNION

		SELECT
			informer, 999 AS hops, visitDate, modifiedDate
		FROM 
			tblInformerDownload
		WHERE 
			visitDate < '%s'
			AND informer NOT IN
			(
				SELECT uri FROM tmpBadURIs
			)

		%s
		
		ORDER BY
			hops,
			visitDate
		;		

		"""  % (maxHops, maxDate, userSQL)
		#--LIMIT 1

	count = 0
	print SQL
	try:
		print "___MDDB:Here we go"
		for	(uri, hops, visitDate, modifiedDate) in cursor.execute(SQL):
			# hack: don't add current user to our list
			if uri == serverVars["userURI"]:
				print "Skipping current user URI",serverVars["userURI"]
				continue
			
			#
			# IMPORTANT: note that <hops> here is not the hops of the informer
			# at <uri>, but the hops of the informer who imports from <uri> (ie, the parent node)
			count += 1
			print "___MDDB:URI: "+uri
			# this is dumb. I wish I had javascript here.							
			uri=("", uri)[bool(uri)]

			informer_element = newdoc.createElement("informer")
			results_element.appendChild( informer_element )

			uri_element = newdoc.createElement("uri")
			uri_element.appendChild( newdoc.createTextNode(uri) )
			informer_element.appendChild( uri_element )

			visitDate_element = newdoc.createElement("visitDate")
			visitDate_element.appendChild( newdoc.createTextNode(visitDate) )
			informer_element.appendChild( visitDate_element )

			modifiedDate_element = newdoc.createElement("modifiedDate")
			modifiedDate_element.appendChild( newdoc.createTextNode(modifiedDate) )
			informer_element.appendChild( modifiedDate_element )

			print "visitDate",visitDate
			print "modifiedDate",modifiedDate

	except apsw.MisuseError: #TODO: WTF is this non-error?
		pass

	print "___MDDB:Result is: ",newdoc.toxml().encode('latin-1')	

	cursor.execute("DROP TABLE tmpBadURIs;")
	
	return newdoc.toxml()	