from xml.dom.minidom import getDOMImplementation
import re, urllib
import apsw
import mddb_URIstripper
import dateFormat, datetime
from random import *

global gSuzanneDateFormat
gSuzanneDateFormat = "Y-m-dTH:i:sZ"

global false, true
true = 1
false = 0


def randomURIset(params, cursor, serverVars):
	print "___MDDB:Doing Random Set"

	# no params
		
	# setup our XML output
	impl = getDOMImplementation()
	newdoc = impl.createDocument(None, "results", None)
	results_element = newdoc.documentElement		
		
	# TODO: sort by hops of the person giving the report...
	SQL = """
		SELECT 
			I.uri,
			I.name,
			I.link,
			I.description,
			I.image,
			I.hops,
			R.scope,
			R.link,
			R.title,
			R.isInformerStatement = '1' AS isInformerStatement2,			
			R.quality,
			R.date,
			R.description,
			R.tags
		FROM
			tblReports R,
			tblInformerProfiles I
		WHERE
			R.quality > 0 		
			AND	R.informer = I.uri
			AND R.isInformerStatement <> '1'
			AND R.informer <> '%s' -- Don't look at your own reports (Do we want this?)			
		ORDER BY
			R.date
		LIMIT
			200
		"""  % (serverVars["userURI"])
	count = 0
	randomList = []
	count = 0
	for ( \
		i_uri, \
		i_name, \
		i_link, \
		i_description, \
		i_image, \
		i_hops, \
		r_scope, \
		r_link, \
		r_title, \
		r_isInformerStatement, \
		r_quality, \
		r_date, \
		r_description, \
		r_tags) \
	in cursor.execute(SQL):
		count += 1

		i_uri=("", i_uri)[bool(i_uri)]
		i_name=("", i_name)[bool(i_name)]
		i_link=("", i_link)[bool(i_link)]
		i_description=("", i_description)[bool(i_description)]
		i_image=("", i_image)[bool(i_image)]
		i_hops=(repr(i_hops))
		r_scope=("", r_scope)[bool(r_scope)]
		r_link=("", r_link)[bool(r_link)]
		r_title=("", r_title)[bool(r_title)]
		r_isInformerStatement=("", r_isInformerStatement)[bool(r_isInformerStatement)]
		r_quality=("", r_quality)[bool(r_quality)]
		r_date=("", r_date)[bool(r_date)]
		r_description=("", r_description)[bool(r_description)]
		r_tags=("", r_tags)[bool(r_tags)]
		
		randomList.append([i_uri, i_name, i_link, i_description, i_image, i_hops, r_scope, r_link, r_title, r_quality, r_date, r_description, r_tags])
	
	reports_element = newdoc.createElement("reports")
	results_element.appendChild(reports_element)
	
	for i in range(6):
		[i_uri, i_name, i_link, i_description, i_image, i_hops, r_scope, r_link, r_title, r_quality, r_date, r_description, r_tags] = randomList[ randrange( len(randomList) ) ]

		# report stuff
		report_element = newdoc.createElement("report")
		reports_element.appendChild( report_element )

		r_scope_element = newdoc.createElement("scope")
		r_scope_element.appendChild( newdoc.createTextNode(r_scope) )
		report_element.appendChild( r_scope_element )
		
		r_link_element = newdoc.createElement("link")
		r_link_element.appendChild( newdoc.createTextNode(r_link) )
		report_element.appendChild( r_link_element )
		
		r_isInformerStatement_element = newdoc.createElement("isInformerStatement")
		r_isInformerStatement_element.appendChild( newdoc.createTextNode(r_isInformerStatement) )
		report_element.appendChild( r_isInformerStatement_element )
		
		r_quality_element = newdoc.createElement("quality")
		r_quality_element.appendChild( newdoc.createTextNode(r_quality) )
		report_element.appendChild( r_quality_element )
		
		r_date_element = newdoc.createElement("date")
		r_date_element.appendChild( newdoc.createTextNode(r_date) )
		report_element.appendChild( r_date_element )
		
		r_description_element = newdoc.createElement("description")
		r_description_element.appendChild( newdoc.createTextNode(r_description) )
		report_element.appendChild( r_description_element )
		
		r_tags_element = newdoc.createElement("tags")
		r_tags_element.appendChild( newdoc.createTextNode(r_tags) )
		report_element.appendChild( r_tags_element )
		
		r_title_element = newdoc.createElement("title")
		r_title_element.appendChild( newdoc.createTextNode(r_title) )
		report_element.appendChild( r_title_element )

		# informer stuff
		informer_element = newdoc.createElement("informer")
		report_element.appendChild( informer_element )

		i_uri_element = newdoc.createElement("uri")
		i_uri_element.appendChild( newdoc.createTextNode(i_uri) )
		informer_element.appendChild( i_uri_element )
		
		i_name_element = newdoc.createElement("name")
		i_name_element.appendChild( newdoc.createTextNode(i_name) )
		informer_element.appendChild( i_name_element )
		
		i_link_element = newdoc.createElement("link")
		i_link_element.appendChild( newdoc.createTextNode(i_link) )
		informer_element.appendChild( i_link_element )
		
		i_description_element = newdoc.createElement("description")
		i_description_element.appendChild( newdoc.createTextNode(i_description) )
		informer_element.appendChild( i_description_element )
		
		i_image_element = newdoc.createElement("image")
		i_image_element.appendChild( newdoc.createTextNode(i_image) )
		informer_element.appendChild( i_image_element )
		
		i_hops_element = newdoc.createElement("hops")
		i_hops_element.appendChild( newdoc.createTextNode(i_hops) )
		informer_element.appendChild( i_hops_element )
		
	return newdoc.toxml()	