from xml.dom.minidom import getDOMImplementation
import re, urllib
import apsw

global false, true
true = 1
false = 0


def searchTags(params, cursor, serverVars):
	URIs = []
	exact = false
	includeProfile = false # include user profile in results
	showSQL = false
	for (param,value) in params:
		if (param=="query"):
			terms=re.split(',',value)
		elif (param=="SQL"):
			showSQL = true
		
	# setup our XML output
	impl = getDOMImplementation()
	newdoc = impl.createDocument(None, "results", None)
	results_element = newdoc.documentElement		
	
	for term in terms:
		# defend against SQL injection
		if (term.find(";")!=-1):
			continue;
	
		reports_element = newdoc.createElement("matches")
		reports_element.setAttribute("term",term)
		results_element.appendChild(reports_element)
		
		#print "___MDDB: processing term":term
		SQL = """
			SELECT 
				T.tag,
				T.uri,
				I.uri,
				I.name,
				I.link,
				I.description,
				I.image,
				I.hops,
				R.scope,
				R.title,
				R.isInformerStatement,
				R.quality,
				R.date,
				R.description,
				R.tags
			FROM
				tblTags T, 
				tblReports R,
				tblInformerProfiles I
			WHERE
				T.tag = '%s'
				AND	T.informer = I.uri
				AND T.informer = R.informer
				AND R.link = T.uri
			ORDER BY
				R.quality DESC, -- TODO: some formula to reduce the effective quality based on hops
				I.hops
			"""  % ( term )
		#print SQL
		count = 0
		for (tag, \
			tag_uri, \
			i_uri, \
			i_name, \
			i_link, \
			i_description, \
			i_image, \
			i_hops, \
			r_scope, \
			r_title, \
			r_isInformerStatement, \
			r_quality, \
			r_date, \
			r_description, \
			r_tags) \
		in cursor.execute(SQL):
			count += 1

			# this is dumb. I wish I had javascript here.							
			tag = str(tag)
			tag_uri = str(tag_uri) 
			i_uri = str(i_uri)
			i_name = str(i_name)
			i_link = str(i_link) 
			i_description = str(i_description) 
			i_image = str(i_image) 
			i_hops = str(i_hops) 
			r_scope = str(r_scope) 
			r_title = str(r_title) 
			r_isInformerStatement = str(r_isInformerStatement) 
			r_quality = str(r_quality) 
			r_date = str(r_date) 
			r_description = str(r_description) 
			r_tags = str(r_tags)
			
#			uri=("", uri)[bool(uri)]
#			name=("", name)[bool(name)]
#			link=("", link)[bool(link)]
#			description=("", description)[bool(description)]
#			image=("", image)[bool(image)]
#			hops=(repr(hops))
#			scope=("", scope)[bool(scope)]
#			link=("", link)[bool(link)]
#			isInformerStatement=("0", "1")[bool(isInformerStatement)]
#			quality=("", quality)[bool(quality)]
#			date=("", date)[bool(date)]
#			description=("", description)[bool(description)]
#			terms=("", terms)[bool(terms)]

			# enforce rules
			if r_isInformerStatement=="1":
				r_scope=""
			if tag_uri==r_scope:
				scope=""
				
			report_element = newdoc.createElement("match")
			reports_element.appendChild( report_element )
								
			tag_element = newdoc.createElement("tag")
			tag_element.appendChild( newdoc.createTextNode(tag) )
			report_element.appendChild( tag_element )
			
			link_element = newdoc.createElement("link")
			link_element.appendChild( newdoc.createTextNode(tag_uri) )
			report_element.appendChild( link_element )
								
			scope_element = newdoc.createElement("scope")
			scope_element.appendChild( newdoc.createTextNode(r_scope) )
			report_element.appendChild( scope_element )
			title_element = newdoc.createElement("title")
			title_element.appendChild( newdoc.createTextNode(r_title) )
			report_element.appendChild( title_element )

			isInformerStatement_element = newdoc.createElement("isInformerStatement")
			isInformerStatement_element.appendChild( newdoc.createTextNode(r_isInformerStatement) )
			report_element.appendChild( isInformerStatement_element )
			quality_element = newdoc.createElement("quality")
			quality_element.appendChild( newdoc.createTextNode(r_quality) )
			report_element.appendChild( quality_element )
			date_element = newdoc.createElement("date")
			date_element.appendChild( newdoc.createTextNode(r_date) )
			report_element.appendChild( date_element )
			description_element = newdoc.createElement("description")
			description_element.appendChild( newdoc.createTextNode(r_description) )
			report_element.appendChild( description_element )
			tags_element = newdoc.createElement("tags")
			tags_element.appendChild( newdoc.createTextNode(r_tags) )
			report_element.appendChild( tags_element )

			informer_element = newdoc.createElement("informer")
			report_element.appendChild( informer_element )

			uri_element = newdoc.createElement("uri")
			uri_element.appendChild( newdoc.createTextNode(i_uri) )
			informer_element.appendChild( uri_element )
			name_element = newdoc.createElement("name")
			name_element.appendChild( newdoc.createTextNode(i_name) )
			informer_element.appendChild( name_element )
			i_link_element = newdoc.createElement("link")
			i_link_element.appendChild( newdoc.createTextNode(i_link) )
			informer_element.appendChild( i_link_element )
			i_description_element = newdoc.createElement("description")
			i_description_element.appendChild( newdoc.createTextNode(i_description) )
			informer_element.appendChild( i_description_element )
			image_element = newdoc.createElement("image")
			image_element.appendChild( newdoc.createTextNode(i_image) )
			informer_element.appendChild( image_element )
			hops_element = newdoc.createElement("hops")
			hops_element.appendChild( newdoc.createTextNode(i_hops) )
			informer_element.appendChild( hops_element )

				
	
#		print SQL
		
#		if showSQL:
#			out = out + "<DEBUG_sql>"+SQL+"</DEBUG_sql>"
#		out = out + "</reports>"				
	
	#print newdoc.toxml().encode('latin-1')	
	return newdoc.toxml()	