from xml.dom.minidom import getDOMImplementation
import re, urllib
import apsw
from Ft.Lib import Uri
from Ft.Xml import InputSource
from Ft.Xml.Xslt.Processor import Processor
from xml.dom.minidom import parseString
import sys
import threading

import dateFormat, datetime
global gSuzanneDateFormat
gSuzanneDateFormat = "Y-m-dTH:i:sZ"

global false, true
true = 1
false = 0

def setStatement(params, cursor, serverVars, data):

	myThread = threading.Thread(target=setStatementThread, args=(params, serverVars, data))
	myThread.start()
	print"___MDDB: setstatement thread began"
	
	# setup our XML output
	impl = getDOMImplementation()
	newdoc = impl.createDocument(None, "results", None)
	results_element = newdoc.documentElement		
	
	return newdoc.toxml()		

def setStatementThread(params, serverVars, data):
	print "___MDDB:set statement begin"
	
	# make our own connection to database
	connection=apsw.Connection(serverVars["db_filename"])
	cursor=connection.cursor()
	
	showSQL = false
	informerURI = ""
	modifiedDate = ""
	comment = ""
	# possible status commands: 
	#	FAIL - could not retrieve data from given URI, or it was not formatted correctly (record our last date of failure)
	#   NO_CHANGE - the data had not changed. (just record the date of our visit)
	#   UPDATE - update the database records about this informer based on the info in <data> 
	status = "FAIL";
	for (param,value) in params:
		print param,"=",value
		if (param=="SQL"):
			showSQL = true
		elif (param=="informerURI"):
			informerURI = value;
		elif (param=="modifiedDate"):
			modifiedDate = value;
		elif (param=="status"):
			status = value;
		elif (param=="comment"):
			comment = value;
		
	d = datetime.datetime.now()
	df = dateFormat.DateFormat(d)
	nowString = df.format(gSuzanneDateFormat)	
	
	#
	# Insert a failure node first ... if things crash later in this function, we want a record of failure
	#
	SQL = """
		REPLACE INTO 
			tblInformerDownload (informer, visitDate, modifiedDate, failDate, comment)
		VALUES
			('%s','%s','%s','%s','%s')
	""" % (informerURI, nowString, modifiedDate, nowString, "Failure or error in setStatement() on MDDB server.")
	try:	
		cursor.execute(SQL)
	except apsw.MisuseError: #TODO: WTF is this "non-error"?
		pass	
		
 	# TODO: we _should_ be able to read the URI from the file, 
 	# but Python's [4suites] XML handling is so messed up that I can't figure it out.
	if informerURI=="":
		print "___MDDB:no informer URI. error"
		return ("<error>No informer uri given</error>");

 	
 	print "___MDDB:status is "+status
 	
 	#
 	# Update data in database
 	#
 	if status=="UPDATE":
		# http://uche.ogbuji.net/tech/akara/nodes/2003-01-01/python-xslt
		# fuck fuck ... worst documented software ever.  Why won't a simple 3 line example code run?
		#doc = NonvalidatingReader.parseString("<spam>eggs<a/><a/></spam>")
		#print doc.xpath('//a')
		#print doc.xpath('string(/spam)')

		## watch out for illegal unicode chars. We're all in utf-8
		uData = unicode(data,'utf8','ignore')
		## stupid 4suite can't handle unicode, so we'll convert back to a string
		encodedData = uData.encode('utf8')
		
		#debugout = open("debugout","w")
		#debugout.write(data)
		#debugout.close()
		
		documentInputSource = InputSource.DefaultFactory.fromString(encodedData, informerURI)	
		stylesheet = InputSource.DefaultFactory.fromUri( Uri.OsPathToUri(serverVars["base_path"]+"xsl/rss1_2_sql.xsl"))
		# See also fromString() and fromStream()	

		#print statementDoc.toprettyxml()
		#print statementDoc.toxml("utf-8")

		print "___MDDB:Applying XSLT"
		processor = Processor()
		processor.appendStylesheet(stylesheet)
		SQL = processor.run(documentInputSource)
		
		# stick informer uri into the SQL
		p = re.compile( '_INFORMER_URI_')
		SQL = p.sub(informerURI, SQL)

		f = open("DEBUG_statementsql.sql","w")
		f.write(SQL);
		f.close();
				
		print "___MDDB:sending SQL to DB. length is "+repr(len(SQL))

		uSQL = unicode(SQL,'utf8','replace')
		
		# TODO: some unicode filtering...what if the data isn't formatted correctly?
		try:	
			cursor.execute(SQL)
		except apsw.MisuseError: #TODO: WTF is this "non-error"?
			pass
		#except:
		#	# something went wrong with out writing to database
		#	print "___MDDB:Problem sending data to database.", sys.exc_info()[0]
		#	status = "FAIL"

		print "___MDDB:Calculating Hops..."

		#
		# re-calculate hops TODO: there is probably an optimized way to do this.
		# It'd be nice to have stored procedures here...
		if (status != "FAIL"):
			# read SQL code for calculating hops
			f = open(serverVars["base_path"]+"sql/hops.sql")
			hopsSQL = f.read();
			# insert user's URI into the SQL code
			p = re.compile( '_USER_URI_')
			hopsSQL = p.sub( serverVars["userURI"], hopsSQL)

			try:
				cursor.execute(hopsSQL)
			except apsw.MisuseError: #TODO: WTF is this "non-error"?
				pass
			except:
				# something went wrong with out writing to database
				print "___MDDB:Problem sending data to database.", sys.exc_info()[0]
				status = "FAIL"


	print "___MDDB:Doing logistic stuff..."
	
	#
	# Remember dates and stuff about our visit
	#	
	visitDate = nowString
	if status == "FAIL":
		failDate = nowString 
	else:
		failDate = ""

	SQL = """
		REPLACE INTO 
			tblInformerDownload (informer, visitDate, modifiedDate, failDate, comment)
		VALUES
			('%s','%s','%s','%s','%s')
	""" % (informerURI, visitDate, modifiedDate, failDate, comment)
	#print status
	#print SQL
	try:	
		cursor.execute(SQL)
	except apsw.MisuseError: #TODO: WTF is this "non-error"?
		pass	

	
	print "___MDDB:Finished update"
	print
	
