from xml.dom.minidom import getDOMImplementation
import apsw
import re
import sys

global false, true
true = 1
false = 0

global gUserURI

def setUserInfo(params, cursor, serverVars):

	# TODO: Why am I doing this update with 2 SQL statements? Couldn't it be just one? (That'd be safer in case of failure.)

	print "___MDDB:userInfo from serverVars=",serverVars["userURI"]
	
	newUserURI      = filter( (lambda (param,value) : param=="uri"), params)[0][1]
	userName        = filter( (lambda (param,value) : param=="name"), params)[0][1]
	userLink        = filter( (lambda (param,value) : param=="link"), params)[0][1]
	userImage       = filter( (lambda (param,value) : param=="image"), params)[0][1]
	userDescription = filter( (lambda (param,value) : param=="description"), params)[0][1]
	userPubKey      = filter( (lambda (param,value) : param=="pubKey"), params)[0][1]
	userTags        = filter( (lambda (param,value) : param=="tags"), params)[0][1]
	#userMaxPing     = filter( (lambda (param,value) : param=="maxPing"), params)[0][1]
	userMaxPing = ""
	
	if newUserURI=="":
		print "Empty string passed for user URI"
		newdoc = impl.createDocument(None, "failure", None)
		return newdoc.toxml()			
	
	success = true
	
	print newUserURI, \
			userName, \
			userLink, \
			userDescription, \
			userImage, \
			userPubKey, \
			userMaxPing, \
			userTags
			
	SQL = """
		BEGIN
		;
		DELETE FROM tblInformerProfiles
		WHERE uri = ?
		;
		REPLACE INTO tblInformerProfiles 
		(
			uri, 
			name, 
			link, 
			description, 
			image, 
			pubKey, 
			maxPing, 
			tags, 
			hops
		)
		VALUES
		(?,?,?,?,?,?,?,?,?)	
		;
		COMMIT
		;
	"""
	print SQL
	
	try:	
		cursor.execute(SQL, \
		( \
			serverVars["userURI"], \
			newUserURI, \
			userName, \
			userLink, \
			userDescription, \
			userImage, \
			userPubKey, \
			userMaxPing, \
			userTags, \
			0) \
		)
	except apsw.MisuseError: #TODO: WTF is this non-error?
		pass
	except :
		print "___MDDB:Failed on SQL REPLACE INTO tblInformerProfiles...", sys.exc_info()[0]
		success = false
	if success:
		print "___MDDB:Changed profile info"
		
	if (success and (newUserURI != serverVars["userURI"])):
		# change the user's URI
		SQL = """
			BEGIN
			;
			REPLACE INTO tblSystemVars (varName,varValue)
			VALUES ('userURI', :newUserURI)
			;
			UPDATE tblReports
			SET informer = :newUserURI
			WHERE informer = :userURI
			;
			UPDATE tblTags
			SET informer = :newUserURI
			WHERE informer = :userURI
			;	
			-- Don't allow user to be informer to himself.  (This would result in his new reports being overwritten when his remote statement is fetched.)
			DELETE FROM tblReports
			WHERE 
				informer = :newUserURI
				AND link = :newUserURI
				AND isInformerStatement = '1'
			;
			COMMIT
			;
			"""		
		print SQL
		try:	
			print "___MDDB:New ",newUserURI
			print "___MDDB:Old ",serverVars["userURI"]
			# TODO: WTF?
			#TypeError: Bad binding argument type supplied - argument #1: ('uri', 'http://www
			#.trustbase.org/users/stan.xml')		
			cursor.execute(SQL, { 'newUserURI':newUserURI , 'userURI':serverVars["userURI"] } )
			success=true
			#p = re.compile( ':newUserURI')
			#hopsSQL = p.sub( "'"+newUserURI+"'", SQL)
			#p = re.compile( ':userURI')
			#hopsSQL = p.sub( "'"+userURI+"'", SQL)
			#cursor.execute(SQL)
		except apsw.MisuseError: #TODO: WTF is this non-error?
			pass
		#except:
		#	print "___MDDB:Failed on UPDATE tblSystemVars...", sys.exc_info()[0]
		#	success=false
	
	# setup our XML output
	impl = getDOMImplementation()
	if (success):
		serverVars["userURI"] = newUserURI #remember our user's new URI
		print "___MDDB:Set gUserURI to ",newUserURI
		newdoc = impl.createDocument(None, "success", None)
	else:
		newdoc = impl.createDocument(None, "failure", None)
	results_element = newdoc.documentElement		


	return newdoc.toxml()	

