<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet 
	xmlns="http://purl.org/rss/1.0/" 
	xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
	xmlns:taxo="http://purl.org/rss/1.0/modules/taxonomy/"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:of="http://trustbase.org/quality/0.1/"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	version="1.0"
>
	
	<xsl:output method="xml" indent="yes"/>


	<xsl:template match="results">

		<xsl:processing-instruction name="xml-stylesheet">
			type="text/xsl" href="outfoxed.xsl"
		</xsl:processing-instruction>
		
		<rdf:RDF
		 xmlns="http://purl.org/rss/1.0/"
		 xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
		 xmlns:taxo="http://purl.org/rss/1.0/modules/taxonomy/"
		 xmlns:dc="http://purl.org/dc/elements/1.1/"
		 xmlns:of="http://trustbase.org/quality/0.1/"
		>
		<xsl:apply-templates select="informer"/>
		<xsl:apply-templates select="report"/>
		</rdf:RDF>
	</xsl:template>
	
	<xsl:template match="informer">
		<channel rdf:about="http://www.trustbase.org/users/stan.xml">
			<title><xsl:value-of select="name"/></title>
			<link><xsl:value-of select="link"/></link>
			<description><xsl:value-of select="description"/></description>
			<image rdf:resource="{image}" />
			<dc:subject><xsl:value-of select="tags"/></dc:subject>
			<items>
			 <rdf:Seq>
			 	<xsl:for-each select="../report">
					<rdf:li rdf:resource="{link}"/>
			 	</xsl:for-each>
			 </rdf:Seq>
			</items>
		</channel>	 
		<image rdf:about="{image}">
			<title><xsl:value-of select="name"/></title>
			<link><xsl:value-of select="link"/></link>
			<url><xsl:value-of select="image"/></url>
		</image>		
	</xsl:template>

	
	<xsl:template match="report">
		<item rdf:about="{link}">
			<title><xsl:value-of select="title"/></title>
			<link><xsl:value-of select="link"/></link>
			<description><xsl:value-of select="description"/></description>
			<dc:creator><xsl:value-of select="../informer/name"/></dc:creator>
			<dc:date><xsl:value-of select="date"/></dc:date>
			<of:quality><xsl:value-of select="quality"/></of:quality>
			<of:scope><xsl:value-of select="scope"/></of:scope>
			<dc:subject><xsl:if test="isInformerStatement='1'">_RSS<![CDATA[ ]]></xsl:if><xsl:value-of select="tags"/></dc:subject>
			<!--
			<taxo:topics>
				<rdf:Bag>
					
				</rdf:Bag>
			</taxo:topics>
			-->
		</item>
	</xsl:template>
	
	<!-- http://www.biglist.com/lists/xsl-list/archives/200109/msg00507.html -->
	<xsl:template match="node()" mode="doTags" name="doTags">
	  <xsl:param name="string" select="." />
	  <xsl:param name="degree" select="100" />
	  <xsl:param name="informer" />
	  <xsl:param name="uri" />
	  
	  <xsl:choose>
	  	<xsl:when test="normalize-space($string) = ''">
	  	<!-- if string is empty, do nothing -->
	  	</xsl:when>
	  
	    <xsl:when test="contains($string, ' ')">
	    <!-- if the string contains a space -->
			INSERT INTO tblTags 
		 		(tag,degree,informer,link)
			VALUES
			(
				'<xsl:value-of select="substring-before($string, ' ')" />',
				<xsl:value-of select="$degree"/>,
				'<xsl:value-of select="$informer"/>',
				'<xsl:value-of select="$uri"/>'
			);
	    	
	      <!-- and then call the template recursively on the rest of the string -->
	      <xsl:call-template name="doTags">
	        <xsl:with-param name="string" select="substring-after($string, ' ')" />
	        <xsl:with-param name="degree" select="$degree" />
	        <xsl:with-param name="informer" select="$informer" />
	        <xsl:with-param name="uri" select="$uri" />
	      </xsl:call-template>
	    </xsl:when>
	    
	    <xsl:otherwise>
	    <!-- if the string doesn't contain a space, just give the tag -->
			INSERT INTO tblTags 
				(tag,degree,informer,uri)
			VALUES
			(
				'<xsl:value-of select="$string" />',
				<xsl:value-of select="$degree"/>,
				'<xsl:value-of select="$informer"/>',
				'<xsl:value-of select="$uri"/>'
			);	      
	    </xsl:otherwise>
	  </xsl:choose>
	</xsl:template>

	
</xsl:stylesheet>