<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet 
xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
version="1.0">

	<xsl:variable name="singquote">'</xsl:variable> <!-- HACK: we need better single quote handling -->
	
	<xsl:output method="text" indent="yes"/>
	<!-- override built-in template for text/atts -->
	<xsl:template match="text()|@*"/>

	<xsl:template match="channel">
		BEGIN;
		<xsl:apply-templates/>
		COMMIT;
	</xsl:template>

	<xsl:template match="profile">
	
		/* Clear out existing report */
		/* TODO: with triggers? */

		DELETE FROM tblInformerProfiles
		WHERE uri = '<xsl:value-of select="uri"/>';

		DELETE FROM tblReports
		WHERE informer = '<xsl:value-of select="uri"/>';

		DELETE FROM tblTags
		WHERE informer = '<xsl:value-of select="uri"/>';


		/* Profile info */
			
		INSERT INTO tblInformerProfiles 
			( uri, name, link, description, image, pubKey, maxPing, tags)
		VALUES
		(
			'<xsl:value-of select="uri"/>',
			'<xsl:value-of select="name"/>',
			'<xsl:value-of select="link"/>',
			'<xsl:value-of select="translate(description,$singquote,'`')"/>',
			'<xsl:value-of select="image"/>',
			'<xsl:value-of select="pubKey"/>',
			'<xsl:value-of select="maxPing"/>',
			'<xsl:value-of select="tags"/>'			
		);
		
	</xsl:template>

	<xsl:template match="report">
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'<xsl:value-of select="../../profile/uri"/>',
			'<xsl:value-of select="scope"/>',
			'<xsl:value-of select="uri"/>',
			0,
			'<xsl:value-of select="trust/@degree"/>',
			'<xsl:value-of select="date"/>',
			'<xsl:value-of select="translate(description,$singquote,'')"/>'
		);			
			
  			<xsl:apply-templates select="tags" mode="doTags" >
  				<xsl:with-param name="degree" select="100" />
	     		<xsl:with-param name="informer" select="../../profile/uri" />
				<xsl:with-param name="target" select="scope" />
			</xsl:apply-templates>
	</xsl:template>
	
	<xsl:template match="informer">
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'<xsl:value-of select="../../profile/uri"/>',
			'<xsl:value-of select="uri"/>',
			'',
			1,
			'<xsl:value-of select="trust/@degre"/>',
			'<xsl:value-of select="date"/>',
			'<xsl:value-of select="translate(description,$singquote,'')"/>'
		);			
	</xsl:template>	
	
	<!-- http://www.biglist.com/lists/xsl-list/archives/200109/msg00507.html -->
	<xsl:template match="node()" mode="doTags" name="doTags">
	  <xsl:param name="string" select="." />
	  <xsl:param name="degree" select="100" />
	  <xsl:param name="informer" />
	  <xsl:param name="target" />
	  <xsl:choose>
	    <!-- if the string contains a space -->
	    <xsl:when test="contains($string, ' ')">
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'<xsl:value-of select="substring-before($string, ' ')" />',
				<xsl:value-of select="$degree"/>,
				'<xsl:value-of select="$informer"/>',
				'<xsl:value-of select="$target"/>'
			);
	    	
	      <!-- and then call the template recursively on the rest of the string -->
	      <xsl:call-template name="doTags">
	        <xsl:with-param name="string" select="substring-after($string, ' ')" />
	        <xsl:with-param name="degree" select="$degree" />
	        <xsl:with-param name="informer" select="$informer" />
	        <xsl:with-param name="target" select="$target" />
	      </xsl:call-template>
	    </xsl:when>
	    
	    <!-- if the string doesn't contain a space, just give the tag -->
	    <xsl:otherwise>
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'<xsl:value-of select="$string" />',
				<xsl:value-of select="$degree"/>,
				'<xsl:value-of select="$informer"/>',
				'<xsl:value-of select="$target"/>'
			);	      
	    </xsl:otherwise>
	  </xsl:choose>
	</xsl:template>

	
</xsl:stylesheet>